POJ 2528 Mayor’s Posters [Sub-segment tree – interval update + Discrete] [Data Structure]

Subject link: http://poj.org/problem?id=2528
——————————————-. < br> Mayor’s posters
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 60379 Accepted: 17492
Description

The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral wall for placing the posters and introduce the following rules:
Every candidate can place exactly one poster on the wall.
All posters are of the same height equal to the height of the wall; the width of a poster can be any integer number of bytes (byte is the unit of length in Bytetown).
The wall is divided into segments and the width of each segment is one byte.
Each poster must completely cover a contiguous number of wall segments.

They have built a wall 10000000 bytes long (such that there is enough plac e for all candidates). When the electoral campaign was restarted, the candidates were placing their posters on the wall and their posters differed widely in width. Moreover, the candidates started placing their posters on wall segments already occupied by other posters. Everyone in Bytetown was curious whose posters will be visible (entirely or in part) on the last day before elections.
Your task is to find the number of visible posters when all the posters are placed given the information about posters’ size, their place and order of placement on the electoral wall.
Input

The first line of input contains a number c giving the number of cases that follow. The first line of data for a single case contains number 1 <= n <= 10000. The subsequent n lines describe the posters in the order in which they were placed. The i-th line among the n lines contains two integer numbers li and ri which are the number of the wall segment occupied by the left end and the right end of th e i-th poster, respectively. We know that for each 1 <= i <= n, 1 <= li <= ri <= 10000000. After the i-th poster is placed, it entirely covers all wall segments numbered li, li+1 ,…, ri.
Output

For each input data set print the number of visible posters after all the posters are placed.

The picture below illustrates the case of the sample input.

Sample Input

1
5
1 4
2 6
8 10
3 4
7 10
Sample Output

4
Source

Alberta Collegiate Programming Contest 2003.10.18
——————————————.

The main idea of ​​the topic:
is to give a continuous interval, brush n kinds of colors in the above n sub-intervals (which can be covered), and ask you how many colors you have leaked at the end.

The idea of ​​problem-solving:
It is to use the line segment tree to maintain each interval and cover the color, and finally calculate the nodes on the leaves to have several colors.

But notice the l,r< /span> The range is 1e8 is so big but n is only 1e6
So we can discretize the calculation.

Note that the discretized interval should be 2e6< /span> Otherwise RE

Attach this question code
——————————–.

/* memory 2104kb time 954ms *///#include #include #include #include < /span>#include #include #include #define abs(x) (((x)>0)?(x):-(x)) #define lalal puts("*********")#define Rep( a,b,c) for(int a=(b);a<=(c);a++)#define Req(a,b,c) for( int a=(b);a>=(c);a--)#define Rop(a,b,c) for(int a=(b) ;a<(c);a++)#define s1(a) scanf("%d",&a)typedef long long int LL;using namespace std; const int inf = 0x3f3f3f3f;const int MOD = 9901;/**************************************/ const int N = 20000+ 5;#define ll (rt<<1)# define rr (rt<<1|1)#define mid (tree[rt].m())struct node{ int l,r; int lazy; int m() {return (l+r)>>1 ;} int len() {return (r-l+ 1); }} tree[N<<2];void build(int rt,int l,int r){ tree[rt].l=l,tree[rt].r=r,tree[rt].lazy=0; if(l==r) return; build(ll,l,mid); build(rr,mid+1,r);}void pushdown(int rt){ if(tree [rt].lazy) {tree[ll].lazy=tree[rr].lazy=tree[rt].lazy; tree[rt].lazy=0 ; }}void update(int rt,int L,int R,int val){ if (L<=tree[rt].l&&tree[rt].r<=R) {tree[rt].lazy=val; return;} pushdown(rt); if(L<=mid) update(ll,L,R,val); if(R >mid) update(rr,L,R,val);}int query(int rt,i nt L,int R){ if(tree[rt].l==tree [rt].r) return tree[rt].lazy; pushdown(rt); if(L <=mid) return query(ll,L,R); if(R> mid) return query(rr,L,R);}map<< span class="hljs-keyword">int ,int >mp,mmp;struct  nod{ int l,r; int ind;}b[N];int c[N];int main(){ int _; while(~s1(_)) {while(_--) {mp. clear(),mmp.clear(); int n,kn=0,cnt=0,color=0; s1(n); int l,r; Rep(i,< span class="hljs-number">1,n) s1(b[i].l),s1(b[i].r),c[i]=b[i].l,c [i+n]=b[i].r; sort(c+1,c+n*2+1); Rep(i,1,n<<1)if(0==mp[c[i]])mp [c[i]]=++kn; build(1,1,kn); Rep( i,1,n) update(1,mp[b[i].l],mp[ b[i].r],i); Rep(i,1,kn) {color=query(1< /span>,i ,i); if(mmp[color]==0) mmp[color]=1,cnt++;} printf("%d
",cnt);}} return 0;}

Title link: http://poj.org/problem?id=2528
——————————————-.
Mayor’s posters
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 60379 Accepted: 17492
Description

The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral wall for placing the posters and introduce the following rules:
Every candidate can place exactly one poster on the wall.
All posters are of the same height equal to the height of the wall; the width of a poster can be any integer number of bytes (byte is the unit of length in Bytetown).
The wall is divided into segments and the width of each segment is one byte.
Each poster must completely cover a contiguous number of wall segments.

They have built a wall 10000000 bytes long (such that there is enough place for all candidates). When the electoral campaign was restarted, the candidates were placing their posters on the wall and their posters differed widely in width. Moreover, the candidates started placing their posters on wall segments already occupied by other posters. Everyone in Bytetown was curious whose posters will be visible (entirely or in part) on the last day before elections.
Your task is to find the number of visible posters when all the posters are placed given the information about posters’ size, their place and order of placement on the electoral wall.
Input

The first line of input contains a numb er c giving the number of cases that follow. The first line of data for a single case contains number 1 <= n <= 10000. The subsequent n lines describe the posters in the order in which they were placed. The i-th line among the n lines contains two integer numbers li and ri which are the number of the wall segment occupied by the left end and the right end of the i-th poster, respectively. We know that for each 1 <= i <= n, 1 <= li <= ri <= 10000000. After the i-th poster is placed, it entirely covers all wall segments numbered li, li+1 ,…, ri.
Output

For each input data set print the number of visible posters after all the posters are placed.

The picture below illustrates the case of the sample input.

Sample Input

1
5
1 4
2 6
8 10
3 4
7 10
Sample Output

4
Source

Alberta Col legiate Programming Contest 2003.10.18
——————————————.

The main idea of ​​the title:
is to give a continuous interval, in the above n sub-intervals (Can be overwritten) Brush on n colors and ask you how many colors are left out at the end.

Question-solving ideas:
It is to use a line segment tree to maintain each interval and cover the color, and finally calculate The nodes on the leaves can have several colors.

But note that < span style="display: inline-block; position: relative; width: 1.141em; height: 0px; font-size: 123%;">l, span>r has a range of 1e8 so Big but n only 1e6< /span>
So it can discretize the calculation.

< p>Note that the discretized interval should be 2e6 Otherwise RE

Attach this question code
——————————–.

/* memory 2104kb time 954ms *///#include #include #include #include #include #include #include  #define abs(x) (((x)>0)?(x):-(x))#define lalal puts("*********")#define Rep(a,b,c) for(int a=(b );a<=(c);a++)#define Req(a,b,c) for(int a=(b);a>=(c) ;a--)#define Rop(a,b,c) for(int a=(b);a<(c);a++) #define s1(a) scanf("%d",&a)typedef long long int LL;using namespace std;const span> int inf = 0x3f3f3f3f;const int MOD = 9901;/******************************** ******/const int N = 20000+5;#define ll (rt<<1)#define rr (rt<<1|1)#define mid (tree[rt].m()) struct node{ int l,r; int lazy; int m() {return (l+r)>>1;} int len() {return (r-l+< span class="hljs-number">1); }} tree[N<<< span class="hljs-number">2];void build(int rt, int l,int r){ tree[rt].l=l,tree[rt].r =r,tree[rt].lazy=0; if(l==r) return; build(ll,l,mid); build(rr,mid+1,r);}void pushdown(int rt){ if(tree[ rt].lazy) {tree[ll].lazy=tree[rr].lazy=tree[rt].lazy; tree[rt].lazy=0; }}void update(int rt,int L,int R,int val){ if< /span>(L<=tree[rt].l&&tree[rt].r<=R) { tree[rt].lazy=val; return;} pushdown(rt); if(L<= mid) update(ll,L,R,val); if(R >mid) update(rr,L,R,val);}int query(int rt,int L,int R){ if(tree[rt].l==tree[rt].r) return tree[rt].lazy; pushdown(rt); if(L<=mid) return query(ll,L,R); if(R> mid) return query(rr,L,R);}map<int< /span> ,int >mp,mmp;struct nod{ int l,r; int ind;}b[N];int c[N];int main(){ int _; while(~s1(_)) {while(_--) {mp.clear(),mmp.clear(); int n ,kn=0,cnt=0,color=0 ; s1(n); int l,r; Rep(i,1,n ) s1(b[i].l),s1(b[i].r),c[i]=b[i].l,c[i+n]=b[i].r; sort(c+ 1,c+n*2+1); Rep(i,1,n<<1)if(0==mp[c[i]])mp[c[i]]=++kn; build(1,1,kn); Rep(i,1,n) update(1,mp[b[i].l],mp[b[i].r],i); Rep(i,1,kn) {color=query(1,i,i); if(mmp[color]==0) mmp[color]=1,cnt++;} printf("%d
",cnt); }} return 0;}

Leave a Comment

Your email address will not be published.